#!/bin/sh

# This little script is for the use of Inform 7 on Linux
#
# You no longer need the wine the windows emulator in order to use it.
# You may prefer to use the official Linux front end located at http://www.inform-fiction.org/I7/Download.html
# You must also have those original folders from the 4S08 inform 7 :
#             Inform7/Extensions, Library, Projects and Inform 
#             (provided with this archive)
#
# You shouldn't change the linux.inform folder in the projects. You can
# only change the story.txt, and create your story in place of this
# one. Your resulting game will be the linux.z8 file.
#
# You might try to use the inform-631.exe intead of the  inform 6 
# compiler for linux but it's not recommended and no longer relevant.
# (it wanted to execute the auto.inf file instead), 
# so comment the lines according to your needs.
#
# (attention dans la version fr, ce qui se refere a enleveaccents a ete retire)
#
# made for the live-cd http://esclinux.tk
# It should be expanded in the future.

# choose your target language there (en or fr) :
# the fr option will use the story-fr.txt version instead of story.txt
TARGET=en

UNIX=linux
#linux or macosx 
if [ $(uname)=Linux ]; then 
echo "Your system should be Linux"
UNIX=linux
fi

# do you want to compile the game with the inform 631 windows version ? 
# (may not work, disabled by default)
INF6WINE=no

# convert accents to opcode ? (not recommended with inform 7, doesn't seem to work)
CONVACC=no

# remove all accented letters ?
RMACC=no

############################

fr="false"
case $LANG in
        fr*) fr="true";;
esac


case $1 in
	"fr")
		TARGET=fr
		;;
	"en")
		TARGET=en
		;;
	"it")
		TARGET=it
		;;
	"spa")
		TARGET=spa
		;;
	"gui")
		python pynform7.py
		exit
		;;
	"help")
		echo "Edit the story.txt file with your own game."
		echo "Use ./compile_ni.sh option1 where option1 can be :"
		echo "	a language choosen between en, fr, it or spa"
		echo "	gui to start the interactive gui"
		echo "	help to display this help"
		echo "Use ./compile_ni.sh option1 option2 to choose option between :"
		echo "	sans_accents (remove all accented letters)"
		echo "	opcode (opcode instead of accented letters, but doesn't work on I7)"
		exit
		;;
	*)
	if $fr
	then 
		echo " "
		echo "'./compile_ni.sh help' to display this help"
		echo "La langue par defaut dans le script est $TARGET"
		echo "Vous pouvez la changer en passant en argument"
		echo " 'en' ou 'fr' a ce script"
		echo " "
	else
		echo " "
		echo "'./compile_ni.sh help' to display this help"
		echo "The default language in the script is set to $TARGET"
		echo "you can choose your own by adding 'en' or 'fr'"
		echo " in argument to this script"
		echo " "
	fi
;;
esac

if [ "$UNIX" = linux ]; then
COMPILER="./inform-6.31-biplatform"
else COMPILER="./inform631-mac"
fi

if  [ "$TARGET" = en ]; then
STORY=story.txt
LGNAME=" +language_name=English"
fi

if [ "$TARGET" = fr ]; then
STORY=story-fr.txt
LGNAME=" +language_name=FrenchN11 "
fi

if  [ "$TARGET" = it ]; then
STORY=story.txt
LGNAME= " " 
fi

if  [ "$TARGET" = spa ]; then
STORY=story.txt
LGNAME= " "
fi

case $2 in
	"opcode")
		CONVACC=yes
		;;
	"sans_accents")
		RMACC=yes
		;;
	"i6")	
		cp $STORY story.inf
		$COMPILER -v8 $LGNAME -wSD +include_path=Library,Library/Natural,./    ./story.inf linux.z8
		exit
		;;
	*)
	if $fr
	then 
		echo " "
		echo ""
	else
		echo " "
		echo ""
	fi
;;
esac


if [ "$CONVACC" = yes ]; then 
RMACC=no
iconv -f utf-8 -t iso-8859-1 $STORY > convert.txt
 sed -e "s//@'e/g"   convert.txt > convert2.txt 
 sed -e "s//@\`a/g"   convert2.txt > convert.txt
 sed -e "s//@\`e/g"   convert.txt > convert2.txt
 sed -e "s//@^u/g"   convert2.txt > convert.txt
 sed -e "s//@^a/g"   convert.txt > convert2.txt
 sed -e "s//@\`u/g"   convert2.txt > convert.txt
 sed -e "s//@^i/g"   convert.txt > convert2.txt
 sed -e "s//@\:i/g"   convert2.txt > convert.txt
 sed -e "s//@:e/g"   convert.txt > convert2.txt
 sed -e "s//@^e/g"   convert2.txt > convert.txt
 sed -e "s//@cc/g"   convert.txt > convert2.txt
 sed -e "s//o/g"   convert2.txt > convert.txt
 sed -e "s//u/g"   convert.txt > convert2.txt
iconv -f iso-8859-1 -t utf-8 convert2.txt > convert.txt
rm convert2.txt
STORY=convert.txt

fi

if [ "$RMACC" = yes ]; then 
iconv -f utf-8 -t iso-8859-1 $STORY > convert.txt
 sed -e "s//e/g"   convert.txt > convert2.txt 
 sed -e "s//a/g"   convert2.txt > convert.txt
 sed -e "s//e/g"   convert.txt > convert2.txt
 sed -e "s//u/g"   convert2.txt > convert.txt
 sed -e "s//a/g"   convert.txt > convert2.txt
 sed -e "s//u/g"   convert2.txt > convert.txt
 sed -e "s//i/g"   convert.txt > convert2.txt
 sed -e "s//i/g"   convert2.txt > convert.txt
 sed -e "s//e/g"   convert.txt > convert2.txt
 sed -e "s//e/g"   convert2.txt > convert.txt
 sed -e "s//c/g"   convert.txt > convert2.txt
 sed -e "s//o/g"   convert2.txt > convert.txt
 sed -e "s//u/g"   convert.txt > convert2.txt
iconv -f iso-8859-1 -t utf-8 convert2.txt > convert.txt
rm convert2.txt
STORY=convert.txt
fi


cp -f $STORY Projects/linux.inform/Source/story.ni

if [ "$UNIX" = linux ]; then
./ni4S08 -rules ./Inform7/Extensions -package ./Projects/linux.inform -extension=z8
else 
./ni-mac -rules ./Inform7/Extensions -package ./Projects/linux.inform -extension=z8
fi




sleep 1 

if [ "$INF6WINE" = yes && "$UNIX" = linux ]; then
	wine inform-631.exe -v8 $LGNAME -wSD  +include_path=Project/linux.inform/Source,Library/Natural,./   Projects/linux.inform/Build/auto.inf linux.z8
else
	$COMPILER -v8 $LGNAME -wSD +include_path=Project/linux.inform/Source,Library/Natural,./    Projects/linux.inform/Build/auto.inf linux.z8
fi



# blorb support maybe in the future ?

#./inform630 -kE2SDwG +language_name=FrenchN11 +include_path=Project/linux.inform/Source,Library/Natural,./  Projects/linux.inform/Build/auto.inf linux.ulx


